/*	acom.h -- information used in common between the configuration
			  modules and both the library and the translator.

	Copyright (c) 1983 by James F. Gimpel
	Copyright (c) 1984 by JMI Software Consultants, Inc.

*/

/*	Types used by BASTOC  */

typedef char BTEXT, *STRING, TBOOL, TEXT, TINY;
typedef short BITS, COUNT, FLAG, TOKEN;
typedef int ARGINT, BOOL, INT, VOID, XCHAR;
#ifndef STDIO_OK
typedef int FILE;
#endif
typedef unsigned BYTES;
typedef long LONG;
typedef float FLOAT;
typedef double DOUBLE;

/*  Storage classes used by BASTOC  */

#define FAST	register
#define GLOBAL	
#define IMPORT	extern
#define EXFUNC  extern
#define INTERN	static
#define LOCAL	static

/*	Manifest Constants used by BASTOC  */

#define NULLCH '\0'
#define NULLSTR ""		/* Null string */
#define ARGORD 1 		/* order of arguments on the stack */
#define NUM_CHARS 128 	/* No. of characters in char. set */

/*  System parameters used by BASTOC  */

#define YES		1
#define NO		0
#define NULL	0
#define FOREVER	for (;;)
#define EOF		-1

/*	macros  */

#define isdigit(c)	('0' <= (c) && (c) <= '9')
#define max(x, y)	(((x) < (y)) ? (y) : (x))
#define min(x, y)	(((x) > (y)) ? (y) : (x))
#define islower(c)	('a' <= (c) && (c) <= 'z')
#define isupper(c)	('A' <= (c) && (c) <= 'Z')
#define tolower(c)	(isupper(c) ? (c) - 'A' + 'a' : (c))
#define toupper(c)	(islower(c) ? (c) - 'a' + 'A' : (c))
