/*	admvar.c -- Administrative Variables (for library)
 
	Copyright (c) 1983 by James F. Gimpel
	Copyright (c) 1983, 1984 by JMI Software Consultants, Inc.

	This module allows tailoring of the Bastoc
	Library to allow for version peculiarities.
 */
#include "acom.h"
#include "adl.h"
#include "host.h"

/*	Administrative variables:

	Administrative variables in the library section are placed
	in a single structure to simplify linking.
 */
struct adm_var avar =
	{
	256,		/* buf_size - size of buffers for bufferd I/O */
	0,			/* margin - maximum number of characters per line,
				   0 indicates no limit */
	1,			/* min_bu - smallest BASIC I/O unit number */
	20,			/* max_bu - largest BASIC I/O unit number */
	7,			/* fltopr - number of digits PRINTed in single precision */
	16,			/* dblopr - number of digits PRINTed in double precision */
	"LPT1:",	/* printer name - LPRINT directs output to this file */
	",",		/* strterm - string termination characters,
				   When inputting strings that are not quoted,
				   the set of termination characters is
				   determined by this string. */
	14,			/* zoneln - zone length for columnar output */
	YES,		/* needcr - need CR at end of output lines */
	YES			/* kybdcr - need CR at end of output lines to keyboard devices */
	};
