/*	rrd.h	Definitions for raw mode input handling routines

	Copyright (c) 1984 by JMI Software Consultants, Inc.
*/

typedef struct
	{
	INT rr_mypid;		/* this process's pid */
	TEXT rr_erase;		/* erase character */
	TEXT rr_kill;		/* kill charater */
	TEXT rr_intr;		/* interrupt character */
	TEXT rr_quit;		/* quit character */
	TEXT rr_eot;		/* end of text character */
	} RR;

/* Input modes understood by the function rawread.
	Any of the following modes can be added together and
	passed to rawread. If more than one mode is specified,
	the modes are processed in ascending numerical order.
*/

#define RR_7BIT		0x0001	/* mask data to 7 bits */
#define RR_CRMOD	0x0002	/* convert CR to NL */
#define RR_UCASE	0x0004	/* convert lower case letters to upper case */
#define RR_LCASE	0x0008	/* convert upper case letters to lower case */
#define RR_ERASE	0x0010	/* process erase characters */
#define RR_KILL		0x0020	/* process kill characters */
#define RR_NECR		0x0040	/* do not echo CR or NL characters */
#define RR_INTR		0x0080	/* process interrupt characters */
#define RR_QUIT		0x0100	/* process quit characters */
#define RR_EOT		0x0200	/* process end of text characters */
#define RR_BSLSH	0x0400	/* process backslash sequences */
#define RR_ECHO		0x0800	/* echo converted input */
#define RR_LINE		0x1000	/* terminate rawread when NL is input */
#define RR_WAIT		0x2000	/* wait for input */
